<template>
  <div>
    <transition-group
      v-bind="{
        ...useTransition,
        name: useTransition.name || 'modal-overlay-transition'
      }"
    >
      <component
        :is="getModalOverlayComponent()"
        v-for="modal in modals"
        :key="modal.modalInstance.name"
        :modal="modal.modalInstance"
      />
    </transition-group>
  </div>
</template>

<script>
import Core from '@/Core'

/**
 * **ModalContainer** component: the parent of all ModalOverlay instances
 */
export default {
  name: 'ModalContainer',
  props: {
    /**
     * A props object to pass to <transition-group> component for ModalOverlay. If defined, must be an object like:
     * ```js
     * {
     *   mode: 'in-out',
     *   enterActiveClass: 'custom-class',
     *   leaveActiveClass: 'another-custom-class',
     *   ...
     * }
     * ```
     *
     * See also: https://v2.fr.vuejs.org/v2/guide/transitions.html#Classes-de-transition-personnalisees
     */
    useTransition: {
      type: Object,
      default () {
        return {}
      }
    }
  },
  data () {
    return {}
  },
  computed: {
    modals: function () {
      // @ts-ignore
      const shownModals = Object.keys(this.$modals) // this.$modalManager.modals
        .reduce((modals, key) => {
          if (this.$modals[key].show) {
            modals[key] = this.$modals[key]
          }
          return modals
        }, {})
      return shownModals
    }
  },
  beforeCreate () {},
  methods: {
    getModalOverlayComponent () {
      return Core.context.vue.components.modals.ModalOverlay
    }
  }
}
</script>

<style>
/**
 * The ID of element add to App scopedSlot
 */
#service\:modal-manager\@modal_container {
  position: relative; /* ⚠ Important for z-index context with position: fixed of ModalOverlay child */
  width: 100%;
  height: 0px;
  overflow: hidden;
}
</style>
